#!/bin/bash
cd /home/srajan/InterFuser ### change this to the path of the InterFuser folder
export CARLA_ROOT=carla
export CARLA_SERVER=${CARLA_ROOT}/CarlaUE4.sh
export PYTHONPATH=$PYTHONPATH:${CARLA_ROOT}/PythonAPI
export PYTHONPATH=$PYTHONPATH:${CARLA_ROOT}/PythonAPI/carla
export PYTHONPATH=$PYTHONPATH:$CARLA_ROOT/PythonAPI/carla/dist/carla-0.9.10-py3.7-linux-x86_64.egg
export PYTHONPATH=$PYTHONPATH:leaderboard
export PYTHONPATH=$PYTHONPATH:leaderboard/team_code
export PYTHONPATH=$PYTHONPATH:leaderboard/team_code_v2
export PYTHONPATH=$PYTHONPATH:scenario_runner
export SCENARIO_RUNNER_ROOT=scenario_runner
export NVIDIA_VISIBLE_DEVICES=$00000000:02:00.0
export CUDA_VISIBLE_DEVICES=1

export LEADERBOARD_ROOT=leaderboard
export CHALLENGE_TRACK_CODENAME=SENSORS
export PORT=2000 # same as the carla server port
export TM_PORT=2500 # port for traffic manager, required when spawning multiple servers/clients
export DEBUG_CHALLENGE=0
export REPETITIONS=1 # multiple evaluation runs
#export ROUTES=leaderboard/data/town06_vivas.xml
export ROUTES=/home/srajan/InterFuser/scenario_runner/srunner/scenarios/ego_route.xml

export TEAM_AGENT=leaderboard/team_code/interfuser_agent.py # agent
export TEAM_CONFIG=leaderboard/team_code/interfuser_config.py # model checkpoint, not required for expert

#export TEAM_AGENT=leaderboard/team_code/tcp_agent.py
#export TEAM_CONFIG=leaderboard/scripts/new.ckpt

#export TEAM_AGENT=leaderboard/team_code_v2/lav_agent_fast.py
#export TEAM_CONFIG=leaderboard/team_code_v2/config.yaml

#export TEAM_AGENT=leaderboard/team_code_garage/sensor_agent.py
#export TEAM_CONFIG=pretrained_models/longest6/tfpp_all_1
#export UNCERTAINTY_THRESHOLD=0.33
#export BENCHMARK=longest6

export SCENARIOS=leaderboard/data/scenarios/town06_sc_vivas.json
export SAVE_PATH=data/eval # path for saving episodes while evaluating
export RESUME=False
export RECORD_PATH=/home/srajan/InterFuser/scenario_runner/results_vivas # path for saving results log file
export VIVAS_RESULTS_METRICS=/home/srajan/InterFuser/scenario_runner/srunner/metrics/examples/vivas_metric.py

python3 ${LEADERBOARD_ROOT}/leaderboard/leaderboard_evaluator.py \
--scenarios=${SCENARIOS}  \
--routes=${ROUTES} \
--repetitions=${REPETITIONS} \
--track=${CHALLENGE_TRACK_CODENAME} \
--agent=${TEAM_AGENT} \
--agent-config=${TEAM_CONFIG} \
--debug=${DEBUG_CHALLENGE} \
--resume=${RESUME} \
--port=${PORT} \
--trafficManagerPort=${TM_PORT} \
--record=${RECORD_PATH} \
--vivas_results_metrics=${VIVAS_RESULTS_METRICS}

