from abc import ABC, abstractmethod

class AbstractConcretizer(ABC):
    """ Abstract class defining a common interface for all specific concretizer
    implementations. """

    @abstractmethod
    def create_scenarios(self, abstract_trace, properties):
        pass

    @abstractmethod
    def retrieve_scenarios(self, abstract_trace, abstract_scenario):
        raise NotImplementedError()

# end of class AbstractConcretizer
