import json

def get_trace(simulation_result):
    res = []
    with open(simulation_result) as src:
        data = json.load(src)
        def getval(d, k):
            if isinstance(d, dict):
                for key in d:
                    yield from getval(d[key], k + [key])
            else:
                yield (".".join(k), d)
        for (key, vals) in getval(data, []):
            while len(res) < len(vals):
                res.append({})
            for i, v in enumerate(vals):
                state = res[i]
                state[key] = v
    return res



