from abc import ABC, abstractmethod
from dataclasses import dataclass, InitVar


@dataclass
class MonitorResult:
    property_result: str
    coverage_result : bool


class AbstractMonitor(ABC):
    """ Abstract class defining a common interface for all specific monitor
    implementations. """

    @abstractmethod
    def run(self, scenario_name, coverage_scenario, simulation_result):
        """
        returns a MonitorResult instance
        """
        pass

# end of class AbstractMonitor

