
import json
import itertools
import os
import matplotlib.pyplot as plt
import re
# define the function to find the union of two or more lists
def union_lists(*lists):
    concatenated_list = list(itertools.chain(*lists))     
    unique_set = set(concatenated_list)
    final_union = list(unique_set)
    return final_union

files = ["Interfuser_coverage.json"]

coverage_results = []
property_failures = []
property_failures_coverage_ok = []
abstract_scenarios = set()
interesting_scenarios = set()
interesting_scenarios_00 = set()
interesting_scenarios_01 = set()
interesting_scenarios_02 = set()
interesting_scenarios_03 = set()
tot_abstract_scenarios = 0
tot_interesting_scenarios = 0
for file in files:
    f = open(file)
    data = json.load(f)

    # Extract the "coverage" list
    if data['coverage']:
        coverage = data['coverage']
    if 'property' in data and 'FAIL' in data['property']:
        crashes = data['property']['FAIL']

    # Initialize a set to store unique abstract scenario numbers
   
    concretizations = {}
    count_00 = 0
    count_01 = 0
    count_02 = 0
    count_03 = 0
    count_000 = 0
    count_010 = 0
    count_020 = 0
    count_030 = 0
    crash_00 = 0
    crash_01 = 0
    crash_02 = 0
    crash_03 = 0
    total_coverage = 0
    total_intscenarios = 0

    # For each file in the list
    if coverage:
        for scenario in coverage:
            # Split the filename on the underscore and dash to get the abstract scenario number
            abstract_scenario = scenario.split('_')[1].split('-')[0]
            # Add the abstract scenario number to the set
            abstract_scenarios.add(abstract_scenario)
            # count coverage for each weather condition
            if scenario.endswith("00.py"):
                count_00 += 1
            if scenario.endswith("01.py"):
                count_01 += 1
            if scenario.endswith("02.py"):
                count_02 += 1
            if scenario.endswith("03.py"):
                count_03 += 1
            if scenario in crashes:
                interesting_scenario = scenario.split('_')[1].split('-')[0]
                interesting_scenarios.add(interesting_scenario)
                if scenario.endswith("00.py"):
                    count_000 += 1
                    interesting_scenarios_00.add(interesting_scenario)
                if scenario.endswith("01.py"):
                    count_010 += 1
                    interesting_scenarios_01.add(interesting_scenario)
                if scenario.endswith("02.py"):
                    count_020 += 1
                    interesting_scenarios_02.add(interesting_scenario)
                if scenario.endswith("03.py"):
                    count_030 += 1
                    if interesting_scenario not in interesting_scenarios_00 and interesting_scenario not in interesting_scenarios_01 and interesting_scenario not in interesting_scenarios_02:
                        interesting_scenarios_03.add(interesting_scenario)
    # Print the number of unique abstract scenarios
    total_coverage = count_00 + count_01 + count_02 + count_03
    tot_abstract_scenarios += total_coverage
    total_intscenarios = count_000 + count_010 + count_020 + count_030
    tot_interesting_scenarios += total_intscenarios
    print(file)
    print("Coverage OK (00):", count_00)
    print("Coverage OK (01):", count_01)
    print("Coverage OK (02):", count_02)
    print("Coverage OK (03):", count_03)
    #print("total coverage:", total_coverage)
    print("Interesting Scenarios (00):", count_000)
    print("Interesting Scenarios (01):", count_010)
    print("Interesting Scenarios (02):", count_020)
    print("Interesting Scenarios (03):", count_030)
    """ print("Unique Interesting Scenarios (00):", (interesting_scenarios_00))
    print("Unique Interesting Scenarios (01):", (interesting_scenarios_01))
    print("Unique Interesting Scenarios (02):", (interesting_scenarios_02))
    print("Unique Interesting Scenarios (03):", (interesting_scenarios_03)) """
    #print("total interesting scenarios:", total_intscenarios)
    if crashes:
        for crash in crashes:
            if crash.endswith("00.py"):
                crash_00 += 1
            if crash.endswith("01.py"):
                crash_01 += 1
            if crash.endswith("02.py"):
                crash_02 += 1
            if crash.endswith("03.py"):
                crash_03 += 1
        print("Property Fail (00):", crash_00)
        print("Property Fail (01):", crash_01)
        print("Property Fail (02):", crash_02)
        print("Property Fail (03):", crash_03)
        print("Property Fail:", len(crashes))
print("(Set union) Coverage OK:", len(abstract_scenarios))
print("(Set union) Intresting Scenarios:", (interesting_scenarios))
print("Total Coverage OK:", tot_abstract_scenarios)
print("Total Interesting Scenarios:", tot_interesting_scenarios)

